#-----------------------------------------------------------------------------
sub osWinUp
#-----------------------------------------------------------------------------
{
  ($thishost) = @_;

  my $leak_records = 0; 
  my $perlpath = ""; 
  my $zF3 = ""; 
  my $zF4 = ""; 

  my $this_line = ""; 

  my $tl_dbname   = ""; 
  my $tl_trunc    = ""; 
  my $tl_tlsize   = ""; 
  my $tl_pctused  = ""; 
  my $tl_drive    = ""; 
  my $tl_drivepct = ""; 
  my $tl_filename = ""; 
  my $tl_growth   = ""; 

  my $lr_jobs     = ""; 
  my $lr_job_cnt  = 0; 

  my $up_flag  = 0; 

  my $mssql_lrc_cnt  = 0; 
  my $mssql_lrc_data = ""; 

  my $ssrs_logdata = ""; 

  my $tlogmultifile_cnt = 0; 
  my $tlogmultifile_data = ""; 

  my @words = (); 

  my @ssrs_failed_reports = (); 

  my %dbspc_reserved_mb = (); 
  my %dbspc_tables_mb   = (); 
  my %dbspc_indexes_mb  = (); 
  my %dbspc_unused_mb   = (); 

  my $totspc_reserved_mb = 0; 
  my $totspc_tables_mb = 0; 
  my $totspc_indexes_mb = 0; 
  my $totspc_unused_mb = 0; 

  my $fileperf_rank = 0; 

  $svcacct_pwexp_days = ""; 
  $svcacct_pwexp_ts = ""; 

  my $repl_max_lag_hrs = -99; 
  my $repl_www; 

  my $missing_goodparms = ""; 
  my $mssql_repl_nda = ""; 

  @sqltrans_data = (); 
  %trans_data    = (); 
  $trans_flag    = 0; 
  $tr_max_dur_hrs = -1; 
  $tr_max_tlog_gb = -1; 

  $activeses_flag    = 0; 
  @activeses_data    = (); 
  %activeses_entries = (); 

  $cpuprocess_flag    = 0; 
  @cpuprocess_data    = (); 
  %cpuprocess_entries = (); 

  #---- Get Instance online data
  ##I don't know why i did this???  up[$thishost] = ""

  $titlehist[$thishost] = "?" if !$titlehist[$thishost];
  $title1[$thishost]    = "?" if !$title1[$thishost];

  #---- BB 28Jul06 - Changed defaults from 95/99 to 90/95
  #---- BB 02Jan11 - Changed defaults from 90/95 to 80/90
  $t_diskwarn[$thishost] = "80" if !$t_diskwarn[$thishost];
  $t_diskcrit[$thishost] = "90" if !$t_diskcrit[$thishost];

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  ##print "HIT2 - $up[$thishost]\n"; 
  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  #---- OLD, Obsolete
  if ($g_history_to_file eq "Y")
  {
    # Check to see if  we need to create history data
    chop($filedate = `date +%C%y.%m.%d`);
    chop($filetimedata= `date +%H:%M:%S`);
    $hist_flag = 0;
    if (system("grep '$titleraw[$thishost]' $hstdir/dbspaces/$filedate > /dev/null 2>&1") != 0)
    {
      &logit("Setting flag to create tblspace history data",$thishost);
      system("rm $tmpflt > /dev/null 2>&1");
      $hist_flag = 1;
    }
  }

  #---- Call PRE Userexit
  if (-x "/opt/dbamon/bin/userexit/inc_osWinUp_pre")
  {
    if (! $inc_userexit) { $inc_userexit = 1; }
    require "inc_oswinup_pre"; 
    &inc_oswinup_pre;
  }

  #---- Start with a clean slate
  $up[$thishost] = "";
  $probeout_osWinUp_file[$thishost] = ""; 

  $perf_timestamp[$thishost] = &getdate;    #---- Save this for later
  $perf_timestamp[$thishost] =~ s/\-/ /;    #---- Save this for later

  $must_connect = 1;

  &remsh("$perlpath[$thishost] $probe[$thishost] up . $probe_parm[$thishost]", $probeout_file[$thishost], $thishost);

  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error)",$thishost);
    return;
  }

  my $db_good_owner = "SA";
  my $db_owner_fix;
  my $db_owner_rollback;
  my $db_owner_counter = 0;
  my $dbs_restoring = 0; 
  my $dbs_offline   = 0; 

  my $dbstatus = "";
  my $agentstatus = "";
  my $total_size = "";
  my $total_used = "";

  my $oldperl_kill = ""; 
  my $oldperl_details = ""; 
  my $oldperl_maxage = ""; 
  my $oldperl_pids = ""; 
  my $oldperl_cnt = 0; 

  my $this_lpim = ""; 

  my $cpu_arch = ""; 

  my $sql_config_msm = ""; 

  $badparms[$thishost] = "";
  $dbcount[$thishost] = "";
  $udbcount[$thishost] = 0;
  undef $tlogdata[$thishost];
  undef $drivedata[$thishost];
  undef $drivegrowthdata[$thishost];
  undef $fgdata[$thishost];
  my $diskdrivedata; 
  my $dbfileperfdata = ""; 
  my $ao_data = ""; 

  $rmt_hostname[$thishost] = ""; 
  $os64bit[$thishost] = ""; 
  $mssql64bit[$thishost] = ""; 

  $target_shift[$thishost] = ""; 

  undef $lrbackup_age_hrs[$thishost]; 
  undef $lrbackup_message[$thishost]; 
  undef $sqljob_data[$thishost]; 

  undef $cluster_name[$thishost]; 
  undef $cluster_status[$thishost]; 
  undef $cluster_onnode[$thishost]; 
  undef $cluster_thisnodestatus[$thishost]; 
  undef $save_config[$thishost];  
  undef %dbsize; 

  open(PROBEOUT, "$probeout_file[$thishost]"  ) || &error_msg("Cannot open input $probeout_file[$thishost] - $!");
  while(<PROBEOUT>)
  {
    &parse;
    ##print;
    #---- Eliminate records that we don'ty care about
    next if $F1 =~ /^2/ && length($F1) == 19; 

    if ($F2 eq "PERF:")    
    {
      $zkey = "SQL_" . $F3; 
      $perf_readings[$thishost]{$zkey} = $F4;
      next;
    }

    #---- dbamon_mssql.pl Stack: SaveConfig:
    if ($F2 eq "Stack:" && $F3 eq "SaveConfig:")    
    {
      $save_config[$thishost] .= $F0; 
      ##print "F0=$F0\n"; 
      next;
    }

    #---- dbamon_mssql.pl SvcsString: MSSQL MSSQL-Agent MSSQL-Browser OSWin
    if ($F2 eq "SvcsString:")
    {
      $services_running[$thishost] = substr($F0,28);
      ##print "DEBUG **Found** ssrs_logdata=$ssrs_logdata\n";
      next;
    }

    #---- dbamon_mssql.pl TargetShift: P
    if ($F2 eq "TargetShift:")    
    {
      $target_shift[$thishost] = $F3;
      next;
    }

    #---- dbamon_mssql.pl DISK_Tot_Size_GB: 142
    if ($F2 eq "DISK_Tot_Size_GB:")    
    {
      $tot_disk_gb[$thishost] = $F3; 
      &metricsInsert("osWinUp()",$thishost,"SPC_ALLDRIVES_GB",".",$F3);
      next;
    }

    #---- dbamon_mssql.pl DISK_Tot_List:    C
    if ($F2 eq "DISK_Tot_List:")    
    {
      $tot_disk_list[$thishost] = $F3; 
      next;
    }

    #---- SYSPERF data
    if ($F2 eq "SYSPERF:")    
    {
      if    ($F3 =~ /^SQL/) { $zkey = $F3; }
      elsif ($F3 =~ /^SSRS/) { $zkey = $F3; }
      elsif ($F3 =~ /^NET/) { $zkey = $F3; }
      else               { $zkey = "SYS_" . $F3; }
      $perf_readings[$thishost]{$zkey} = $F4;

      #---- For pulling out a value needed in osWinUp
      ## print "$P SYSPERF: SQL_LPIM_Locked_KB $Data[0]\n";
      if ($F3 eq "SQL_LPIM_Locked_KB") 
      { 
        if ($F4 > 0) { $this_lpim = "On";  }
        else         { $this_lpim = "Off"; } 
      } 
  
      next;
    }

    if ($F2 eq "DRIVESTATUS:")    
    {
      #---- dbamon_mssql.pl DRIVESTATUS: E 52094 43768 8326 84.02
      $drivedata[$thishost] .= $F0;
      $dr_drive = (split(/ /,$F0)) [2];
      $dr_size  = (split(/ /,$F0)) [3];
      $dr_used  = (split(/ /,$F0)) [4];
      $dr_free  = (split(/ /,$F0)) [5];
      $dr_pct   = (split(/ /,$F0)) [6];

      my $dr_pct_int = int($dr_pct); 

      #---- Save this for later
      $up_flag = 1; 

      ##print "DRIVESTATUS $titleraw[$thishost] $F0" if $dr_pct >= 90;
      #---- Data validation
      $ev_cat = "Mgmt";
      &event("C",$thishost,"Invalid Data: Drive=($dr_drive) shows a total size of ZERO - Something may be wrong with WMI?","DriveNG","DBA990",$tmpfl2) if $dr_size == 0;

      $color = "lightblue";

      if ($dr_drive ne "" && $dr_pct > 0) 
      {
        &metricsCurrent("osWinUp()",$thishost,"DRIVE_PCT_FULL",$dr_drive,$dr_pct,$t_diskwarn[$thishost],$t_diskcrit[$thishost],"Drives that contain SQL Data") unless $t_diskwarn[$thishost] eq "N"; 
      }

      open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
      print TMPFL2 "Drive:         $dr_drive\n";
      print TMPFL2 "Drive Size:    $dr_size (mb)\n";
      print TMPFL2 "Space Used:    $dr_used (mb)\n";
      print TMPFL2 "Space Free:    $dr_free (mb)\n";
      print TMPFL2 "Percent Full:  ${dr_pct} (percent)\n";
      close(TMPFL2);

      if ($t_diskwarn[$thishost] && $t_diskwarn[$thishost] ne "N")
      {
        if ($dr_pct >= $t_diskcrit[$thishost])
        {
          $ev_cat = "Space";
          &event("C",$thishost,"Drive $dr_drive is ${dr_pct_int} percent full (Critical threshold: $t_diskcrit[$thishost] percent)","DriveFullC","DBA805",$tmpfl2);
          $color = "pink";
          $zdrivestatus = "Critical"; 
        }
        elsif ($dr_pct >= $t_diskwarn[$thishost])
        {
          $ev_cat = "Space";
          &event("W",$thishost,"Drive $dr_drive is ${dr_pct_int} percent full (Warning threshold: $t_diskwarn[$thishost] percent)","DriveFullW","DBA805",$tmpfl2);
          $color = "yellow";
          $zdrivestatus = "Warning"; 
        }
        else
        {
          $color = "lime";
          $zdrivestatus = "OK"; 
        }
      }

      $diskdrivedata .= "
      <tr bgcolor=$color>
        <td>$f_s <b> $dr_drive </b>
        <td align=right>$f_s $dr_size
        <td align=right>$f_s $dr_used
        <td align=right>$f_s $dr_free
        <td align=right>$f_s <b> ${dr_pct}% </b>
        <td align=right>$f_s ${t_diskwarn[$thishost]}%
        <td align=right>$f_s ${t_diskcrit[$thishost]}%
        <td align=right>$f_s <b> $zdrivestatus </b>
      ";

      &metricsInsert("osWinUp()",$thishost,"DRIVE_PCT_FULL",$dr_drive,$dr_pct) if $dr_pct > 0;
      next;
    }

    if ($F2 eq "OS64BIT:" && $F3 == 1)    
    {
      $os64bit[$thishost] .= "(64bit)";
      next;
    }

    if ($F2 eq "MEM_PCT:")    
    {
      $mem_pct[$thishost] = $F3; 
      next;
    }
    if ($F2 eq "MEM_AVAIL:")  
    { 
      $mem_avail[$thishost] = $F3; 
      next;
    }
    if ($F2 eq "MEM_USED:")   
    { 
      $mem_used[$thishost] = $F3; 
      next;
    }
    if ($F2 eq "RAM:")        
    { 
      $ram[$thishost] = $F3; 
      $hw_memory[$thishost] = $F3; 

      #---- For "summarize"
      $total_shmem[$thishost] = $hw_memory[$thishost];

      next;
    }

    if ($F2 eq "UPTIME:")  #---- New
    {
      $str_c = $F3;
      $str_n = $F4;
      $end_c = $F5;
      $end_n = $F6;
      &uptimeLog($thishost);

      $mssql_started = $str_c;
      $mssql_seconds_up = $end_n - $str_n;
      $mssql_upfor_hours = sprintf("%.2f",($mssql_seconds_up / (60*60)));
      $mssql_upfor_days[$thishost]  = sprintf("%.2f",($mssql_seconds_up / (60*60*24)));
      ##print "str_c=$str_c end_c=$end_c str_n=$str_n end_n=$end_n mssql_second_up=$mssql_seconds_up mssql_upfor_hours=$mssql_upfor_hours\n"; 
      next;
    }

    if ($F2 eq "OLDPERL:")    
    {
      $oldperl_details .= substr($F0,25); 
      $z = substr($F6,6); 
      $oldperl_maxage = $z if $z > $oldperl_maxage;
      $oldperl_cnt++;
      $zpid = substr($F3,4); 
      $oldperl_kill .= "<b>C:\\dbatools\\pskill $zpid</b>\n"; 
      $oldperl_pids .= "$zpid "; 
      next;
    }

    # dbamon_mssql.pl CLUSTERNAME: LSCASQLTEST
    # dbamon_mssql.pl CLUSTERSTATUS: Online
    # dbamon_mssql.pl CLUSTERONNODE: WCOSDBT1
    # dbamon_mssql.pl CLUSTERTHISNODESTATUS: Passive
    if ($F2 eq "CLUSTERNAME:")           {  $cluster_name[$thishost] = $F3; next; }
    if ($F2 eq "CLUSTERSTATUS:")         {  $cluster_status[$thishost] = $F3; next; }
    if ($F2 eq "CLUSTERONNODE:")         {  $cluster_onnode[$thishost] = $F3; next; }
    if ($F2 eq "CLUSTERTHISNODESTATUS:") {  $cluster_thisnodestatus[$thishost] = $F3; next; }

    if ($F2 eq "NET_IP:")      {  $net_ip[$thishost] = $F3 ; next; }
    if ($F2 eq "NET_VLAN:")    {  $net_vlan[$thishost] = $F3 ; next; }
    if ($F2 eq "NET_COMPANY:") {  $net_company[$thishost] = $F3 ; next; }

    #---- DaysSinceLastReboot: 2.17
    #---- OLD: 
    ##if ($Fz eq "DaysSinceLastReboot:")  { $os_days_since_last_reboot[$thishost] = $F2; next; }
    #---- NEW:
    #----   dbamon_mssql.pl OS_LastReboot:           2012/07/06-15:01:37
    #----   dbamon_mssql.pl OS_LastRebootDaysSince:  0.03
    if ($F2 eq "OS_LastRebootDaysSince:")  { $os_days_since_last_reboot[$thishost] = $F3; next; }
    if ($F2 eq "OS_LastReboot:")           { $os_last_reboot[$thishost] = $F3; next; }

    if ($F2 eq "PERLPATH:")           { $perlpath = $F3; next; }

    if ($F2 eq "CPUClockSpeedMHz:")     {  $hw_clockspeedmhz[$thishost] = $F3; next; }
    if ($F2 eq "CPUArch:")              {  $cpu_arch = $F3; next; }
    if ($F2 eq "OSVer:")       
    {  
      $os_version[$thishost] = "$F3 $F4"; 
      $sw_version[$thishost] = $F3; 
      next; 
    }
    if ($F2 eq "NumCPUs:")     {  $hw_processors[$thishost] = $F3; next; }

    if ($F2 eq "CPUModel:")    {  $hw_model[$thishost] = $F3; next; }

    if ($F2 eq "HOSTNAME:")    {  $rmt_hostname[$thishost] = $F3; next; }
    if ($F2 eq "RSHService:")  {  $rsh_service[$thishost] = $F3; next; }
    if ($F2 eq "ServerType:")  {  $server_type[$thishost] = $F3; next; }

    #---- We really should never get here
    $leak_records++; 
    ##print "DEBUG_osWinUp: $F0";
  }
  close(PROBEOUT);

  ##print "DEBUG_osWinUp: leak_records=$leak_records\n";

  $ztotal_size = sprintf "%9.2f",$total_size;
  $ztotal_used = sprintf "%9.2f",$total_used;
  ##print "$ztotal_size $ztotal_used \n";

  if ($sw_version[$thishost] lt $ver_oswin_low  || $ver_oswin_low eq "" ) { $ver_oswin_low  = $sw_version[$thishost] }
  if ($sw_version[$thishost] gt $ver_oswin_high || $ver_oswin_high eq "") { $ver_oswin_high = $sw_version[$thishost] }

  $system_size[$thishost] = $total_size / 1000;  
  $system_used[$thishost] = $total_used / 1000;  
  ##print "su=$system_used[$thishost] $title[$thishost] \n";
  $grand_total_size += ($total_size / 1000);  

  if ($os_mode[$thishost] eq "") 
  { 
    if    ($hw_model[$thishost] =~ /64/) { $os_mode[$thishost] = '64'; }
    elsif ($hw_model[$thishost] =~ /86/) { $os_mode[$thishost] = '32'; }
    else                                 { $os_mode[$thishost] = ''; }
  }

  if (! $hw_processors[$thishost]) { $hw_processors[$thishost] = 1; }

  #---- Optionally process MSSQL Svc Acct PW expiration
  &osWinUpSvcAcct;

  &logDetails($thishost,"<br><a name='osWinUpSERVER'> <h3>Server/OS Information</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>OS Type:<td align=right>$f_s $os[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>OS Version:<td align=right>$f_s $os_version[$thishost] $os64bit[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>OS Mode:<td align=right>$f_s $os_mode[$thishost]<td>$f_s (32, 64 or Blank)");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Last Reboot:<td align=right>$f_s $os_last_reboot[$thishost]<td>$f_s");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Days Since Last Reboot:<td align=right>$f_s $os_days_since_last_reboot[$thishost]<td>$f_s");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Processor Type:<td align=right>$f_s $hw_model[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Processor Speed:<td align=right>$f_s $hw_clockspeedmhz[$thishost] MHz");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Processor Architecture:<td align=right>$f_s $cpu_arch (Bit)");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Server Memory Total (MB):<td align=right>$f_s $hw_memory[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Server Memory Available(MB):<td align=right>$f_s $mem_avail[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Server Memory % Used:<td align=right>$f_s ${mem_pct[$thishost]}%");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Server Processor Count:<td align=right>$f_s $hw_processors[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET IP Address:<td align=right>$f_s $net_ip[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET VLAN:<td align=right>$f_s $net_vlan[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET Company:<td align=right>$f_s $net_company[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET FQHostName:<td align=right>$f_s $fqhostname[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>NET ServerLoc:<td align=right>$f_s $serverloc[$thishost]");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>PERLPATH:<td align=right>$f_s $perlpath");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>Target Shift:<td align=right>$f_s $target_shift[$thishost] <td>$f_s Current Work Shift: (P)rime, (W)eekend or (N)ight");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>CMDB Data (If Any)</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Parameter<th>$f_s Value<th>$f_s Comments</tr>");
  &logDetails($thishost,"<tr bgcolor=$table_rowcolor><td>$f_s <b>CMDB Contacts:<td>$f_s $star_contacts[$thishost] ");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<br><a name='osWinUpDRIVE'> <h3>Disk Drive Data</h3>");
  &logDetails($thishost,"<table border=0 bgcolor=$table_bgcolor>");
  ##&logDetails($thishost,"<tr bgcolor=$table_headbgcolor><th>$f_s Drive <th>$f_s Size (mB)<th>$f_s Used (mB)<th>$f_s Free (mB)<th>$f_s Percent Full</tr>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Drive 
    <th>$f_s Size (MB)
    <th>$f_s Used (MB)
    <th>$f_s Free (MB)
    <th>$f_s Percent <br> Full
    <th>$f_s Warning <br>Threshold 
    <th>$f_s Critical <br> Threshold 
    <th>$f_s Current <br> Status 
  </tr>");
  &logDetails($thishost,$diskdrivedata);
  &logDetails($thishost,"</table><hr>");

  if ($hist_flag)
  {
    &logit("Creating tablespace history data in ${hstdir}/dbspaces/${filedate}",$thishost);
    system("sort $tmpflt >> ${hstdir}/dbspaces/${filedate} ");
  }

  #---- Old Perl processes
  if ($oldperl_cnt > 0)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- Report of Old Perl Processes Which Should Be Killed:\n";
    print TMPFL2 "$oldperl_details";
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- DOS Commands to Kill These Processes:\n";
    print TMPFL2 "$oldperl_kill";
    print TMPFL2 "$dashes\n";
    print TMPFL2 "-- List of PIDs to Kill:\n";
    print TMPFL2 "$oldperl_pids";
    print TMPFL2 "$dashes\n";
    ##print TMPFL2 `cat $probeout_file[$thishost]`;
    close(TMPFL2);
    $ev_cat = "Perf";
    &event("C",$thishost,"$oldperl_cnt Old Perl process(es) found - Max process age: $oldperl_maxage hours - Threshold: 12 hours","PerlOldProc","DBA802",$tmpfl2);
  }

  #---- Process SWVER data to see if we are running the right version of SQL
  foreach $this_entry (@swver_data)
  {
    next if $this_entry !~ /^$dbmsout[$thishost]/;
    @words = split(/ /,$this_entry);
    $this_family = $words[1];
    $this_minver = $words[2];
    ##print "$titleraw[$thishost] $sw_version[$thishost] - Found this_family=$this_family this_minver=$this_minver\n";

    #---- Continue only if this is OUR family
    next if $sw_version[$thishost] !~ /^$this_family/;

    $z = length($this_minver);
    ##print "  z=$z \n";
    if (substr($sw_version[$thishost],0,$z) lt $this_minver)
    {
      $ev_cat = "Mgmt";
      &event("U",$thishost,"$dbmsout[$thishost] Version $sw_version[$thishost] is older than the minimum 'good' version ($this_minver) for this family ($this_family)","SWVER-OldVer","DBA652");
      last;
    }
  }

  #---- Log any needed metric history rows
  #($caller, $h, $c, $p, $v, $v2, $v3) = @_;
  &metricsInsert("osWinUp()",$thishost,"SERVER_MEM_PCT",".",$mem_pct[$thishost]);
  &metricsInsert("osWinUp()",$thishost,"SERVER_MEM_TOT",".",$ram[$thishost]);
  &metricsInsert("osWinUp()",$thishost,"SERVER_MEM_USED",".",$mem_used[$thishost]);

  &metricsCurrent("osWinUp()",$thishost,"SERVER_MEM_PCR","" ,$mem_pct[$thishost] ,"" ,"" ,"Percent of Server RAM In Use"); 

  &metricsInsert("osWinUp()",$thishost,"S_CPU_BUSY_SQL",".",$cpu_busy_with_sql[$thishost]) if $cpu_busy_with_sql[$thishost] > 0;

  &metricsCurrent("osWinUp()",$thishost,"S_CPU_BUSY_SQL","" ,$cpu_busy_with_sql[$thishost] ,"" ,"" ,"Percent CPU Util. by SQL "); 

  #---- CPUProcess SNAPSHOT
  if ($cpuprocess_flag)    #---- If we did find any DDP CPU Process entries
  {
    &osWinUpSnapCPUProcess;
  }

  if ($up_flag == 1)    #---- If we did find any DDP CPU Process entries
  {
    $up[$thishost] = "Y"; 
  }

  #---- Userexit - POST
  if (-x "/opt/dbamon/bin/userexit/inc_osWinUp")
  {
    if (! $inc_userexit)
    {
      #---- Moved to main
      $inc_userexit = 1;
    }
    require "inc_oswinup"; 
    &inc_oswinup;
  }
}
#-----------------------------------------------------------------------------
#---- End of osWinUp
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
sub osWinUpSvcAcct
#-----------------------------------------------------------------------------
{
  #---- Optionally process MSSQL Svc Acct PW expiration
  if ($config_parm{'mssql_svc_acct_check'} eq "Y" && $mssql_service_account[$thishost] ne "") 
  {
    my $debug_ac       = 0; 
    my $svcacct_t_warn = 60;
    my $svcacct_t_crit = 30;
    my $svcacct_ts     = "??";

    my ($svcacct_return, $svcacct_ts) = &sqlSvcAcctSelect($mssql_service_account[$thishost]); 
    print "After select, svcacct_return=$svcacct_return svcacct_ts=$svcacct_ts\n" if $debug_ac; 

    if ($svcacct_return > -999999)    #---- Do we have a valid value?
    {
      #---- Just in case
      open(TMPFL2, ">$tmpfl2") || &error_msg("Cannot open output $tmpfl2 - $!");
      print TMPFL2 "Service Account:          $mssql_service_account[$thishost]\n";
      print TMPFL2 "Date When PW Will Expire: $svcacct_ts\n";
      print TMPFL2 "Days Until PW Expiration: $svcacct_return\n";
      print TMPFL2 "Warning Threshold:        $svcacct_t_warn (Days)\n";
      print TMPFL2 "Critical Threshold:       $svcacct_t_crit (Days)\n";
      close(TMPFL2);

      if ($svcacct_return <= $svcacct_t_crit)  #---- Are we at or below the CRITICAL threshold (days)?
      {
        print "CRIT event\n" if $debug_ac; 
        $ev_cat = "Avail";
        &event("C",$thishost,"MSSQL SvcAcct=$mssql_service_account[$thishost] Exception - Password Will Expire LE $svcacct_t_crit Days","SvcAcctPWExp","DBA945", $tmpfl2);
      } 
      elsif ($svcacct_return <= $svcacct_t_warn)  #---- Are we at or below the WARNING threshold (days)?
      {
        print "WARN event\n" if $debug_ac; 
        $ev_cat = "Avail";
        &event("W",$thishost,"MSSQL SvcAcct=$mssql_service_account[$thishost] Exception - Password Will Expire LE $svcacct_t_warn Days","SvcAcctPWExp","DBA945", $tmpfl2);
      }
      else
      {
        print "NO event\n" if $debug_ac; 
      }
      #---- For WWW output above
      $svcacct_pwexp_ts   = $svcacct_ts;
      $svcacct_pwexp_days = $svcacct_return;
    }
  }
}

# -----------------------------------------------------------------------------
sub osWinUpSnapCPUProcess
# -----------------------------------------------------------------------------
{
  my $debug_cpuprocess = 0; 

  my $sn_key = &snapshotsKeyGen("Windows_Processes_Using_CPU"); 
  &snapshotsInsert($thishost, $sn_key, 0, "Windows Active Processes - Using at Least 10 Percent of a CPU"); 
  print "Hit1\n" if $debug_cpuprocess;

  my $table_heading = "<tr bgcolor=$table_headbgcolor>
    <th>$f_s Windows<br>Process ID 
    <th>$f_s Windows<br>Process Name 
    <th>$f_s CPU<br>% 
    <th>$f_s Windows<br>Process<br>Private Bytes
    <th>$f_s Windows<br>Process<br>Age
  </tr>";

  &snapshotsInsert($thishost, $sn_key, 1, $table_heading); 
  print "Hit2\n" if $debug_cpuprocess;
  my $sn_seq = 1; 

  foreach $this_line (split('\n',$cpuprocess_data[$thishost]))
  {
    &packetParse($this_line) if $this_line =~ /^DDP:/;
    $pa_counter = -1;
    foreach $this_field (@pa_words)
    {
      $pa_counter++;
      print "DEBUG_PA: pa_words[$pa_counter]=($this_field)\n" if $debug_cpuprocess == 1;
      $this_verb = (split(/\=/,$this_field)) [0];
      $this_noun = (split(/\=/,$this_field)) [1];

      #---- Remove leading and trailing quotes from data field (after = sign)
      $this_noun =~ s/^'//;
      $this_noun =~ s/'$//;

      $cpuprocess_entries{$this_verb} = $this_noun;
    }

    print "DEBUG_TRAN: sn_spid=$cpuprocess_entries{'sn_name'} sn_waittime=$cpuprocess_entries{'sn_waittime'}\n" if $debug_cpuprocess ;

    #---- DEBUG_PA: pa_words[2]=(sn_process_name='perl#2') DEBUG_PA: pa_words[3]=(sn_cpu_pct='97') DEBUG_PA: pa_words[4]=(sn_private_bytes='25632768') DEBUG_PA: pa_words[5]=(sn_elapsed_seconds='10') DEBUG_PA: pa_words[6]=(sn_process_desc='')

    #---- WWW Details Line
    my $zage = $cpuprocess_entries{'sn_elapsed_seconds'};
    my $zage_out = ""; 

    if    ($zage <  3600) { $zage_out = sprintf("%.2f", $zage / 60 )   . " Minutes"; }
    elsif ($zage < 86400) { $zage_out = sprintf("%.2f", $zage / 3600)  . " Hours"; }
    else                  { $zage_out = sprintf("%.2f", $zage / 86400) . " Days"; }
    
    if    ($cpuprocess_entries{'sn_cpu_pct'} >= 75) { $cp_color = "pink"; }
    elsif ($cpuprocess_entries{'sn_cpu_pct'} >= 50) { $cp_color = "orange"; }
    else                                            { $cp_color = "yellow"; }

    my $table_row = "<tr bgcolor=$cp_color>
      <td align=right> $f_s   $cpuprocess_entries{'sn_id_process'} 
      <td>             $f_s   $cpuprocess_entries{'sn_process_name'} 
      <td align=right> $f_s   $cpuprocess_entries{'sn_cpu_pct'}
      <td align=right> $f_s   $cpuprocess_entries{'sn_private_bytes'}
      <td align=left>  $f_s   $zage_out 
    ";
    &snapshotsInsert($thishost, $sn_key, ++$sn_seq, $table_row); 
    print "Hit3 sn_key=$sn_key\n" if $debug_cpuprocess;
  } 
}

#-----------------------------------------------------------------------------
1;
