#-------------------------------------------------------------------------------
sub instanceBookmarkCheck
#-------------------------------------------------------------------------------
{
  ($h) = @_;

  $debug_ibs = 0; 
  $ib_mins_ago = -99;

  $sql  = "select
    datediff(ss,max(ib_ts), getdate()) as bookmark_mins_ago
  from dbamon.instance_bookmark
  where
    ib_dbc_filename = '$dbcfilename[$h]'";

  $sth = $dbh->prepare($sql) || &error_msg("DB_Prepare eventOCheck - SQL Error=$DBI::errstr SQL=$ovr_statement","","","Y");
  $sth->execute || &error_msg("DB_Execute eventOCheck - SQL Error=$DBI::errstr SQL=$ovr_statement","","","Y");

  while (@Data = $sth->fetchrow_array)
  {
    $ib_mins_ago = sprintf("%.2f", $Data[0] / 60);
  }

  print "DEBUG - ib_mins_ago=$ib_mins_ago\n" if $debug_ibs;
  return $ib_mins_ago;
}
#-------------------------------------------------------------------------------
1;
