# -----------------------------------------------------------------------------
sub osWinReqFile
# -----------------------------------------------------------------------------
{
  #---- Create a require file of parms for this instance
  my $zdate = &getdate;
  open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
  print TMPFL6 "#---- START Require file for Instance=\[$titleraw[$thishost]\] - Created $zdate\n"; 
  print TMPFL6 "\$rq_backup_age         = '$backup_age[$thishost]';\n";
  print TMPFL6 "\$rq_id1                = '$id1[$thishost]';\n";
  print TMPFL6 "\$rq_id2                = '$id2[$thishost]';\n";
  print TMPFL6 "\$rq_id3                = '$id3[$thishost]';\n";
  print TMPFL6 "\$rq_dbamonmode         = '$modeout';\n";

  #---- If the specified mssql_job_lr_check_name_excl_string - then include it. 
  #if ($mssql_job_lr_check_name_excl_string[$thishost])
  #{
  #  print TMPFL6 "\$rq_mssql_job_lr_check_name_excl_string = \"$mssql_job_lr_check_name_excl_string[$thishost]\";\n";
  #}

  #---- Return to caller (DownloadSW.pl)
  print TMPFL6 "#---- END   Require file for $titleraw[$thishost]\n"; 
  print TMPFL6 "1;\n"; 
  close(TMPFL6);

  #---- Copy to the download DIR
  use File::Copy;
  move("$tmpfl6", "$tmpdir/dbamon_oswin_req.pl") || &error("Cannot MOVE TMPFL6=$tmpfl6 to download dir - $!");
  $reqfile[$thishost] = "dbamon_oswin_req.pl";

  return;
}     

# -----------------------------------------------------------------------------
1;
